-module(wsHer).

-include("eWSrv.hrl").

-export_type([callback/0, callback_mod/0, callback_args/0, result/0]).

%% @type callback(). A tuple of a {@type callback_mod()} and {@type
%% callback_args()}.
-type callback() :: {callback_mod(), callback_args()}.

%% @type callback_mod(). A callback module.
-type callback_mod() :: module().

%% @type callback_args(). Arguments to pass to a {@type callback_mod()}.
-type callback_args() :: list().

-type result() ::
   {response_code() |ok, headers(), {file, file:name_all()}|
   {file, file:name_all(), wsUtil:range()}}|
   {response_code() | ok, headers(), body()}|
   {response_code() | ok, body()}|
   {chunk, headers()}|
   {chunk, headers(), body()}|
   ignore.

-callback init(Req :: wsReq(), Args :: callback_args()) -> {ok, standard | handover}.

-callback handle(Req :: wsReq(), callback_args()) -> result().


-callback preprocess(Req1 :: wsReq(), Args :: callback_args()) -> Req2 :: wsReq().

-callback postprocess(Req :: wsReq(), Res1 :: result(), Args :: callback_args()) -> Res2 :: result().

-optional_callbacks([
   init/2
   , preprocess/2
   , postprocess/3
]).
